//FFSubmenu=Skalieren
//FFName=Skalieren auf Maxwerte fr Hhe/Breite

// uncomment the following line, if the script should run as extension
// within the FF batch processing
if(!running) return;

// this is the max size, change this according your to your needs
var maxWidth    = 800;
var maxHeight   = 600;

// nothing to do, if there is no image
if(FF_GetImageWidth() == 0) {
   FF_MessageBox("kein Bild geladen",0);
   FF_ErrorBreak(0);
}
   
//compute the new image sizes
var x, y;
if (FF_GetImageHeight() < FF_GetImageWidth()) {
   x    = maxWidth;
   y    = FF_GetImageHeight() * x/FF_GetImageWidth();
}
else {
   y    = maxHeight;
   x    = FF_GetImageWidth() * y/FF_GetImageHeight();
}

// scale; there are two alternatives
// uncomment this for simple scaling
// FF_HQScale(x, y, false);
// step scale: scale in several steps with intermediate sharpening
StepScale(x,y);

// show the actual image
FF_Reload();

// ??
image_modified = 1;


//======================================================
// Reduces the size and sharpens the image step by step
// @param width image width
// @param height image height
//======================================================
function StepScale(width, height) {

 while (true) {
  var wstep = FF_GetImageWidth();
  var hstep = FF_GetImageHeight();

  if(wstep < width  * 2) break;  //Wenn akt. Bildgroesse unter 
  if(hstep < height * 2) break;  //die doppelte Zielgroesse fllt, 

  FF_HQScale(wstep/2,hstep/2, false); // Halbieren der Groee
  FF_Sharp(32, true, true, true);    // aufhoeren zu verkleinern
 }
 
 FF_HQScale(width, height, false);
 FF_Sharp(32, true, true, true);
}

